# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Python_learn
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023-08-08 6:01
# Description:
# 
# ---------------------------------------------------------------------------
import logging

import allure
import pytest

from learn.example0807.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM系统")
    @pytest.mark.parametrize("module,interface,title,level,request_method,case_url,mime,case_data,except_data,sql_type,sql_sentence,updata_key",ReadExcel().get_data())
    def test_bpm(self,req_fix,db_fix,module,interface,title,level,request_method,case_url,mime,case_data,except_data,sql_type,sql_sentence,updata_key):
        allure.dynamic.feature(module)
        allure.dynamic.story(interface)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)
        if sql_type == "delete":
            db_fix.delete_sql(sql_sentence)
        elif sql_type == "select":
            result = db_fix.select_sql(sql_sentence)
            case_data[updata_key] = result
        elif sql_type == "delete|select" or sql_type == "select|delete":
            db_fix.delete(sql_sentence["delete"])
            select_result = db_fix.select(sql_sentence["select"])
            case_data[updata_key] = select_result
        result = req_fix.request_all(req_method=request_method, req_url=case_url, req_mime=mime, case_data=case_data)
        print(result.text)
        try:
            for key in except_data:
                assert except_data[key] == result.json().get(key)
        except:
            print("断言失败")
            raise AssertionError("断言失败")
        else:
            print("断言成功")
if __name__ == '__main__':
    pytest.main()





