# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Python_learn
# FileName:      conftest.py
# Author:       xxxxxxx
# Datetime:     2023-08-08 6:33
# Description:
# 
# ---------------------------------------------------------------------------
import pytest

from learn.example0807.common.read_db import DB
from learn.example0807.requests_method.requests_method import Requests


@pytest.fixture(scope="session")
def req_fix():
    req = Requests()
    yield req

@pytest.fixture(scope="session")
def db_fix():
    db = DB()
    yield db
    db.close()

def pytest_collection_modifyitems(items):
    # item表示每个测试用例，解决用例名称中文显示问题
    for item in items:
        item.name = item.name.encode("utf-8").decode("unicode-escape")
        item._nodeid = item._nodeid.encode("utf-8").decode("unicode-escape")