# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Python_learn
# FileName:      read_ini.py
# Author:       xxxxxxx
# Datetime:     2023-08-07 18:43
# Description:
# 
# ---------------------------------------------------------------------------
import configparser
import os


class ReadIni:
    def __init__(self):
        self.common_path = os.path.join(os.path.dirname(os.path.dirname(__file__)),"config_data")
        ini_path = os.path.join(self.common_path,"config.ini")
        self.conf = configparser.ConfigParser()
        self.conf.read(ini_path, encoding="utf-8")

    def get_filepath(self,key):
        file_path = self.conf.get("file",key).strip()
        return os.path.join(self.common_path,file_path)
    def get_hostpath(self,key):
        return self.conf.get("host",key).strip()
    def get_tablepath(self,key):
        return self.conf.get("table",key).strip()
    def get_sqlepath(self,key):
        return self.conf.get("sql",key).strip()






if __name__ == '__main__':
    read_ini = ReadIni()

